unit bench1;
{
 Simple benchmark program for hard drives, floppies and ZIP drives.
 Written by Arthur Hoornweg (arthur.hoornweg@email.de)

 Written for Delphi 3.0, but should also run under 2.0
 



 Disclaimer:
 I accept no responsibility for any damage done to your system and/or data.
 This program was written for my own use, and released to the public only
 because of my good will.


 This source is Freeware!
 Feel free to distribute freely.
}


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, ExtCtrls;

type
  TForm1 = class(TForm)
    DriveComboBox1: TDriveComboBox;
    Label1: TLabel;
    Button1: TButton;
    Panel1: TPanel;
    Label2: TLabel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Panel2: TPanel;
    Label3: TLabel;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    Panel3: TPanel;
    Label4: TLabel;
    RadioButton9: TRadioButton;
    RadioButton10: TRadioButton;
    procedure RadioButton3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    Buffer:Pointer;
    BLocksize:longint;
    Testsize:Longint;
    { Public-Deklarationen }
  Procedure SetBlockSize(i:Longint);
  procedure StartReadTest;
  procedure StartWriteTest;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}




Procedure tform1.SetBlockSize(i:Longint);
begin
 Blocksize:=i;
end;




procedure TForm1.RadioButton3Click(Sender: TObject);
VAR s:string;
begin
  WITH sender as tradiobutton do
  begin
    s:=caption;
    SetBlockSize(StrToInt(s));
   end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 Getmem(buffer,65536);
 Blocksize:=65536;
 testsize:=10*1024*1024;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 Getmem(buffer,65536);
end;

procedure TForm1.RadioButton2Click(Sender: TObject);
VAR s:string;
begin
  with sender as tradiobutton do
  begin
   s:=copy(caption,1,2);
   s:=trim(s);
   Testsize:=Strtoint(s)*1024*1024;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if radiobutton9.checked then startReadTest else startwritetest;
end;




FUNCTION RandomName:Ansistring;
VAR f:integer;
begin
  Setlength(Result,8);
  for f:=1 to 8 do Result[f]:=CHR(random(10)+48);
  result:=result+'.TMP';
end;




procedure TForm1.StartReadTest;
VAR
    written:integer;
    Handle:THandle;
    s:Ansistring;
    bps,f,Start,Stop,startpos,fpos,Numblocks : Longint;

begin
    s:=drivecombobox1.Drive+':\'+randomname;
    TRY

    Handle:=CreateFile(
       pchar(s),
       generic_read or generic_write,
       0,
       NIL,
       CREATE_ALWAYS,
         file_attribute_normal OR
          FILE_FLAG_WRITE_THROUGH OR
          file_flag_sequential_scan or
          FILE_FLAG_DELETE_ON_CLOSE,
       0);
      IF handle<=0 then raise einouterror.create('');

      {Create the file}
      Startpos :=testsize-blocksize;
      Numblocks:=testsize div blocksize;

      {Write a single byte to the end of the file (this makes the
       file BIG without the data being in memory cache)           }
      Fpos:=SetFilePointer(Handle,StartPos,nil,file_begin);
      if fpos<>startpos then raise einouterror.create('');
      if not  WriteFile(Handle,buffer^,blocksize,written,NIL) then
        raise einouterror.create('');

      {write data to disk}
      FlushFileBuffers(handle);

      {seek to start of file}
      Fpos:=SetFilePointer(Handle,0,nil,file_begin);

      Screen.cursor:=crHourglass;

      Start:=GetTickCount;
      for f:=1 to numblocks do
      if not ReadFile(Handle,buffer^,blocksize,written,nil) then
         raise einouterror.create('');
      Stop :=GetTickCount;

      Screen.cursor:=crDefault;
      CloseHandle(Handle);
      Handle:=0;
      try
       bps:=ROUND((testsize div ((stop-start))) / 1.024);
       SHowMessage(format('Read speed is %d kb/sec',[bps]));
      except
        SHowMessage('Number too big');
      end;
    Except
      SHowMessage('Cannot create file');
      if handle>0 then closehandle(handle);
    End;
end;

procedure TForm1.StartWriteTest;
VAR
    written:integer;
    Handle:THandle;
    s:Ansistring;
    bps,f,Start,Stop,startpos,fpos,Numblocks : Longint;

begin
    s:=drivecombobox1.Drive+':\'+randomname;
    TRY

    Handle:=CreateFile(
       pchar(s),
       generic_read or generic_write,
       0,
       NIL,
       CREATE_ALWAYS,
          file_attribute_normal OR
          {FILE_FLAG_WRITE_THROUGH OR}
          file_flag_random_access or
          FILE_FLAG_DELETE_ON_CLOSE,
       0);
      IF handle<=0 then raise einouterror.create('');

      {Create it with the correct size}
      Startpos :=testsize-blocksize;
      Numblocks:=testsize div blocksize;

      Fpos:=SetFilePointer(Handle,StartPos,nil,file_begin);
      if fpos<>startpos then raise einouterror.create('');

     if not  WriteFile(Handle,buffer^,blocksize,written,NIL) then
       raise einouterror.create('');

      FlushFileBuffers(handle);

      Fpos:=SetFilePointer(Handle,0,nil,file_begin);

      Screen.cursor:=crHourglass;

      Start:=GetTickCount;
      for f:=1 to numblocks do
      if not WriteFile(Handle,buffer^,blocksize,written,nil) then
         raise einouterror.create('');
      FlushFileBuffers(handle);
      Stop :=GetTickCount;{wait until file is flushed}


      CloseHandle(Handle);
      Handle:=0;
      Screen.cursor:=crDefault;
      try
       bps:=ROUND((testsize div ((stop-start))) / 1.024);
       SHowMessage(format('Write speed is %d kb/sec',[bps]));
      except
        SHowMessage('Number too big');
      end;
    Except
      SHowMessage('Cannot create file');
      if handle>0 then closehandle(handle);
    End;
end;




end.
